CodeForces 545B

Description

Little Susie loves strings. Today she calculates distances between them. As Susie is a small girl after all, her strings contain only digits zero and one. She uses the definition of Hamming distance:

We will define the distance between two strings s and t of the same length
consisting of digits zero and one as the number of positions i, such that si isn‘t
equal to ti.

As besides everything else Susie loves symmetry, she wants to find for two strings s and t of
length n such string p of length n,
that the distance from p to s was equal to the distance from p to t.

It‘s time for Susie to go to bed, help her find such string p or state that it is impossible.

Input

The first line contains string s of length n.

The second line contains string t of length n.

The length of string n is within range from 1 to 105.
It is guaranteed that both strings contain only digits zero and one.

Output

Print a string of length n, consisting of digits zero and one, that meets the problem statement. If no such string exist, print on a single line "impossible" (without the quotes).

If there are multiple possible answers, print any of them.

Sample Input

Input

0001
1011

Output

0011

Input

000
111

Output

impossible

Hint

In the first sample different answers are possible, namely — 0010, 0011, 0110, 0111, 1000, 1001, 1100, 1101.

思路:输入两个相同长度的字符串s1,s2,找一个字符串和s1,s2的相似度一样,例如和s1有两个一样的,则和s2也需要两个一样的。s1,s2的不一样的字符需是偶数个才能找到和他们相似度一样的。

#include<stdio.h>
#include<string.h>
#define N 100010
int main()
{
 int len,i;
 char s1[N],s2[N];
 while(~scanf("%s%s",s1,s2))
 {
    int k=2;
    int n=0;
   len=strlen(s1);
   for(i=0;i<=len-1;i++)
   {
     if(s1[i]!=s2[i])
     {
      n++;
     }

   }
   if(n%2!=0)
   {
     printf("impossible\n");
continue;
   }
     for(i=0;i<=len-1;i++)
     {
     if(s1[i]==s2[i])
     {
       printf("0");
     }
     else
     {
       if(k%2)
         printf("%c",s1[i]);
       else
         printf("%c",s2[i]);
        k++;
     }
 }
printf("\n");
 }

  return 0;

}

版权声明:本文为博主原创文章,未经博主允许不得转载。

时间: 2024-10-28 16:01:58

CodeForces 545B的相关文章

CodeForces 545B Equidistant String (模拟)

[题目链接]:click here~~ [题目大意]: 题意:求一个字符串,使得它与S,T,相似度相差相等. [思路]:就是找出S,T之间的相差个数,相差为奇数,输出impossible.输出为偶数的话不同的前半部分输出S后半部分输出T就好了. 代码: /* * Problem: CodeForces 545B * Running time: 0MS * Complier: G++ * Author: herongwei * Create Time: 8:11 2015/9/17 星期四 */

【codeforces 718E】E. Matvey&#39;s Birthday

题目大意&链接: http://codeforces.com/problemset/problem/718/E 给一个长为n(n<=100 000)的只包含‘a’~‘h’8个字符的字符串s.两个位置i,j(i!=j)存在一条边,当且仅当|i-j|==1或s[i]==s[j].求这个无向图的直径,以及直径数量. 题解:  命题1:任意位置之间距离不会大于15. 证明:对于任意两个位置i,j之间,其所经过每种字符不会超过2个(因为相同字符会连边),所以i,j经过节点至多为16,也就意味着边数至多

Codeforces 124A - The number of positions

题目链接:http://codeforces.com/problemset/problem/124/A Petr stands in line of n people, but he doesn't know exactly which position he occupies. He can say that there are no less than a people standing in front of him and no more than b people standing b

Codeforces 841D Leha and another game about graph - 差分

Leha plays a computer game, where is on each level is given a connected graph with n vertices and m edges. Graph can contain multiple edges, but can not contain self loops. Each vertex has an integer di, which can be equal to 0, 1 or  - 1. To pass th

Codeforces Round #286 (Div. 1) A. Mr. Kitayuta, the Treasure Hunter DP

链接: http://codeforces.com/problemset/problem/506/A 题意: 给出30000个岛,有n个宝石分布在上面,第一步到d位置,每次走的距离与上一步的差距不大于1,问走完一路最多捡到多少块宝石. 题解: 容易想到DP,dp[i][j]表示到达 i 处,现在步长为 j 时最多收集到的财富,转移也不难,cnt[i]表示 i 处的财富. dp[i+step-1] = max(dp[i+step-1],dp[i][j]+cnt[i+step+1]) dp[i+st

Codeforces 772A Voltage Keepsake - 二分答案

You have n devices that you want to use simultaneously. The i-th device uses ai units of power per second. This usage is continuous. That is, in λ seconds, the device will use λ·ai units of power. The i-th device currently has bi units of power store

Educational Codeforces Round 21 G. Anthem of Berland(dp+kmp)

题目链接:Educational Codeforces Round 21 G. Anthem of Berland 题意: 给你两个字符串,第一个字符串包含问号,问号可以变成任意字符串. 问你第一个字符串最多包含多少个第二个字符串. 题解: 考虑dp[i][j],表示当前考虑到第一个串的第i位,已经匹配到第二个字符串的第j位. 这样的话复杂度为26*n*m*O(fail). fail可以用kmp进行预处理,将26个字母全部处理出来,这样复杂度就变成了26*n*m. 状态转移看代码(就是一个kmp

Codeforces Round #408 (Div. 2) B

Description Zane the wizard is going to perform a magic show shuffling the cups. There are n cups, numbered from 1 to n, placed along the x-axis on a table that has m holes on it. More precisely, cup i is on the table at the position x?=?i. The probl

Codeforces 617 E. XOR and Favorite Number

题目链接:http://codeforces.com/problemset/problem/617/E 一看这种区间查询的题目,考虑一下莫队. 如何${O(1)}$的修改和查询呢? 令${f(i,j)}$表示区间${\left [ l,r \right ]}$内数字的异或和. 那么:${f(l,r)=f(1,r)~~xor~~f(1,l-1)=k}$ 记一下前缀异或和即可维护. 1 #include<iostream> 2 #include<cstdio> 3 #include&l